/******************************************************************************
*                                                                             *
*    Map.h                                  Copyright(c) 2007-2010 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef ANT_MAP_H
#define ANT_MAP_H


class AntMap
{
	struct KeyInfo {
		void *pKey;
		void *pValue;
	};
	KeyInfo *m_pArray;
	int m_MapSize;
	int m_AllocSize;
	int m_Cursor;

public:
	AntMap();
	~AntMap();
	int GetCount() const { return m_MapSize; }
	void *GetFirstValue();
	void *GetNextValue();
	bool Lookup(void *Key,void*& Value) const;
	void RemoveKey(void *Key);
	void RemoveValue(void *Value);
	void SetAt(void *Key,void *Value);
};


#endif	// ndef ANT_MAP_H
