/******************************************************************************
*                                                                             *
*    AuthenticManager.h                     Copyright(c) 2007-2010 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef AUTHENTICMANAGER_H
#define AUTHENTICMANAGER_H


#include "rmaauth.h"


class AntAuthenticationManager : public IRMAAuthenticationManager
{
	LONG m_lRefCount;
	~AntAuthenticationManager();

public:
	AntAuthenticationManager();
// IUnknown
	STDMETHOD_(ULONG,AddRef)();
	STDMETHOD_(ULONG,Release)();
	STDMETHOD(QueryInterface)(REFIID iid,void **ppObj);
// IRMAAuthenticationManager
	STDMETHOD(HandleAuthenticationRequest)(
								IRMAAuthenticationManagerResponse *pResponse);
};


#endif	// AUTHENTICMANAGER_H
